#!/bin/sh
#
# $Ringlet: sh/misc/leafports/leafports.sh,v 1.1 2005/02/02 10:28:42 roam Exp $

TDIR=`mktemp -d -t leafports`
trap "rm -rf $TDIR/; echo 'leafports interrupted' 1>&2; exit 1" TERM INT HUP

[ -n "${LEAFDEBUG}" ] && echo "Using temp dir $TDIR"

awk -F: '$1 == "@comment ORIGIN" { print $2 }' /var/db/pkg/*/+CONTENTS | \
	sort -u > $TDIR/origin.lst
awk -F: '$1 == "@comment DEPORIGIN" { print $2 }' /var/db/pkg/*/+CONTENTS | \
	sort -u > $TDIR/deporigin.lst
diff -u $TDIR/deporigin.lst $TDIR/origin.lst > $TDIR/origin.diff

if [ -z "${NOWEIRD}" ] && egrep -q '^-[^-]' $TDIR/origin.diff; then
	echo "WEIRD PORTS:"
	egrep '^-[^-]' $TDIR/origin.diff
	echo "END OF WEIRD PORTS"
fi

if [ -z "${NOLEAF}" ]; then
	if [ -z "${ONLYLEAF}" ]; then
		egrep '^\+[^+]' $TDIR/origin.diff
	else
		sed -ne '/^+[^+]/ { s/^+//; p; }' $TDIR/origin.diff
	fi
fi

rm -rf $TDIR/
